﻿using System;
using System.IO;
using Encryption;

namespace SuperHero
{
    class SaveSystem
    {
        Communicate64Encryption encryption = new Communicate64Encryption();

        string tempPath;
        string path;

        public SaveSystem()
        {
            this.path = string.Format(@"{0}\Save.SAV", Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location));
            this.tempPath = string.Format(@"{0}\temp.SAV", Path.GetTempPath());
        }

        public void write(Hero hero)
        {
            string toEncrypt;

            check(tempPath);
            IniFile ini = new IniFile(tempPath);
            ini.WriteValue("plyr", "name", hero.name);
            ini.WriteValue("plyr", "age", hero.age.ToString());
            ini.WriteValue("plyr", "money", hero.money.ToString());
            ini.WriteValue("plyr", "awards", hero.awards);
            ini.WriteValue("plyr", "armor", hero.armor);
            ini.WriteValue("plyr", "weapon", hero.weapon);
            ini.WriteValue("plyr", "accesoire", hero.accesoire);
            ini.WriteValue("plyr", "power", hero.power);
            ini.WriteValue("plyr", "won", hero.wonTimes.ToString());

            using (StreamReader read = new StreamReader(tempPath))
            {
                toEncrypt = read.ReadToEnd();   
            }
            File.Delete(tempPath);

            string toBeWritten = encryption.encrypt(toEncrypt);

            File.Delete(path);
            check(path);
            using (StreamWriter write = new StreamWriter(path))
            {
                write.Write(toBeWritten);
            }
        }

        public void load(Hero hero)
        {
            string toDecrypt;
            check(path);
            using (StreamReader read = new StreamReader(path))
            {
                toDecrypt = read.ReadToEnd();
            }

            check(tempPath);
            using (StreamWriter write = new StreamWriter(tempPath))
            {
                write.Write(encryption.decrypt(toDecrypt));
            }

            IniFile ini = new IniFile(tempPath);
            hero.name = ini.ReadValue("plyr", "name");
            hero.age = Convert.ToInt32(ini.ReadValue("plyr", "age"));
            hero.armor = ini.ReadValue("plyr", "armor");
            hero.weapon = ini.ReadValue("plyr", "weapon");
            hero.accesoire = ini.ReadValue("plyr", "accesoire");
            hero.money = Convert.ToInt32(ini.ReadValue("plyr", "money"));
            hero.wonTimes = Convert.ToInt32(ini.ReadValue("plyr", "won"));
            hero.power = ini.ReadValue("plyr", "power");
            hero.awards = ini.ReadValue("plyr", "awards");

            File.Delete(tempPath);
        }

        public void check(string path, bool isDirectory = false)
        {
            if (!isDirectory)
            {
                if (!File.Exists(path))
                {
                    using (File.Create(path)) { }
                }
            }
            else
            {
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                }
            }
        }
    }
}
